unit Unit2;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ShellCtrls, ExtCtrls,
  ButtonPanel, StdCtrls;

type

  { TMyFileDialog }

  TMyFileDialog = class(TForm)
    ButtonPanel1: TButtonPanel;
    Panel2: TPanel;
    ShellListView1: TShellListView;
    ShellTreeView1: TShellTreeView;
    Splitter1: TSplitter;
    procedure OKButtonClick(Sender: TObject);
  private
    function GetFileName: String;
    procedure SetFileName(const AValue: String);

  public
    function Execute: Boolean;
    property FileName: String read GetFileName write SetfileName;

  end;

var
  MyFileDialog: TMyFileDialog;

implementation

{$R *.lfm}

function TMyFileDialog.Execute: boolean;
begin
  Result := (ShowModal = mrOK);
end;

procedure TMyFileDialog.OKButtonClick(Sender: TObject);
begin
  if ShellListview1.Selected = nil then
  begin
    ShowMessage('No file selected.');
    ModalResult := mrNone;
  end;
end;

function TMyFileDialog.GetFileName: String;
begin
  if ShellListView1.Selected <> nil then
    Result := ShellListView1.GetPathFromItem(ShellListview1.Selected)
  else
    Result := '';
end;

procedure TMyFileDialog.SetFileName(const AValue: String);
begin
  ShellTreeView1.Path := ExtractFileDir(ExpandFileName(AValue));
  ShellListView1.Selected := ShellListView1.FindCaption(0, ExtractFileName(AValue), false, false, false);
end;

end.
